From 31bedb4eba12422b38545c6fe47e23230718d8ad Mon Sep 17 00:00:00 2001
From: Meghan Richardson <mrichard@fedoraproject.org>
Date: Jul 31 2015 20:19:55 +0000
Subject: [PATCH 209/254] Merge branch 'develop' of pagure.io:fedora-hubs into develop


---

diff --git a/hubs/validators.py b/hubs/validators.py
index cd3d7f6..5bdf053 100644
--- a/hubs/validators.py
+++ b/hubs/validators.py
@@ -3,6 +3,9 @@ import kitchen.text.converters
 import hubs.models
 
 
+def required(session, value):
+    return bool(value)
+
 def text(session, value):
     return kitchen.text.converters.to_unicode(value)
 
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 06a3b79..d3ae5b5 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -10,6 +10,7 @@ from hubs.widgets import fedmsgstats
 from hubs.widgets import feed
 from hubs.widgets import subscriptions
 from hubs.widgets import cobwebs
+from hubs.widgets import meetings
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -29,6 +30,7 @@ registry = {
     'feed': feed,
     'subscriptions': subscriptions,
     'cobwebs': cobwebs,
+    'meetings': meetings,
 
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
diff --git a/hubs/widgets/meetings.py b/hubs/widgets/meetings.py
new file mode 100644
index 0000000..517ee92
--- /dev/null
+++ b/hubs/widgets/meetings.py
@@ -0,0 +1,74 @@
+#from hubs.hinting import hint, prefixed as _
+from hubs.widgets.base import argument
+from hubs.widgets.chrome import panel
+
+from hubs import validators
+
+import arrow
+import collections
+import datetime
+import jinja2
+import requests
+
+chrome = panel('Reminders', key='meetings')
+
+def next_meeting(meetings):
+    now = datetime.datetime.utcnow()
+    for meeting in meetings:
+        string = "%s %s" % (meeting['meeting_date'],
+                            meeting['meeting_time_start'])
+        dt = datetime.datetime.strptime(string, "%Y-%m-%d %H:%M:%S")
+
+        if now < dt:
+            meeting['human_time'] = arrow.get(dt).humanize()
+            meeting['start_date'] = dt.strftime('%b %d')
+            # Just UTC for now until we do this on the client and can access
+            # their local with moment.js.
+            meeting['start_time'] = meeting['meeting_time_start'][:-3] + " UTC"
+            meeting['location'] = meeting['meeting_location']
+            if '@' in meeting['location']:
+                meeting['location'] = '#' + meeting['location'].split('@')[0]
+            return meeting
+
+    return None
+
+jinja2_environment = jinja2.Environment()
+jinja2_environment.filters['next_meeting'] = next_meeting
+template = jinja2_environment.from_string("""
+{% if meetings %}
+    {% for title, items in meetings.items() %}
+        {% set next = items | next_meeting %}
+        {% if next %}
+        The {{ next.meeting_name }} is {{ next.human_time }}
+        <h1 class='inline'>{{next.start_date}}</h1>
+        <div class='inline'>
+            @{{next.start_time}}<br/>
+            {{next.location}}
+        </div>
+        {% endif %}
+        {% if meetings | length > 1 %}
+        <hr/>
+        {% endif %}
+    {% endfor %}
+{% endif %}
+""")
+
+
+@argument(name="calendar",
+          default=None,
+          validator=validators.required,
+          help="A fedocal calendar.")
+def data(session, widget, calendar):
+    base = 'https://apps.fedoraproject.org/calendar/api/meetings/?calendar=%s'
+    url = base % calendar
+    response = requests.get(url).json()
+
+    meetings = collections.defaultdict(list)
+    for meeting in response['meetings']:
+        meetings[meeting['meeting_name']].append(meeting)
+
+    return dict(meetings=dict(meetings))
+
+
+def should_invalidate(message, session, widget):
+    raise NotImplementedError()
diff --git a/hubs/widgets/rules.py b/hubs/widgets/rules.py
index 7afc67b..ce50aff 100644
--- a/hubs/widgets/rules.py
+++ b/hubs/widgets/rules.py
@@ -22,6 +22,23 @@ template = jinja2.Template("""
         </div>
     {% endfor %}
   </div>
+  {% if schedule_text or schedule_link or minutes_link %}
+  <h6>meetings</h6>
+  {% if schedule_text %}
+  <p>{{schedule_text}}</p>
+  {% endif %}
+  <p>
+  {% if schedule_link %}
+  <a target="_blank" href="{{schedule_link}}">Meeting Schedule</a>
+  {% endif %}
+  {% if schedule_link and minutes_link %}
+  &#8214;
+  {% endif %}
+  {% if minutes_link %}
+  <a target="_blank" href="{{minutes_link}}">Past Meeting Minutes</a>
+  {% endif %}
+  </p>
+  {% endif %}
 </div>
 <style>
   .rules-table {
@@ -39,10 +56,22 @@ template = jinja2.Template("""
 @argument(name='link', default=None,
           validator=validators.link,
           help="Link to the community rules and guidelines")
-def data(session, widget, link):
+@argument(name='schedule_text', default=None,
+          validator=validators.text,
+          help="Some text about when meetings are")
+@argument(name='schedule_link', default=None,
+          validator=validators.link,
+          help="Link to a schedule for IRC meetings, etc..")
+@argument(name='minutes_link', default=None,
+          validator=validators.link,
+          help="Link to meeting minutes from past meetings..")
+def data(session, widget, link, schedule_text, schedule_link, minutes_link):
     owners = widget.hub.owners
     owners = ordereddict([(o.username, avatar(o.username)) for o in owners])
-    return dict(owners=owners, link=link)
+    return dict(owners=owners, link=link,
+                schedule_text=schedule_text,
+                schedule_link=schedule_link,
+                minutes_link=minutes_link)
 
 
 @hint(topics=[_('hubs.widget.update'), _('hubs.hub.update')])
diff --git a/populate.py b/populate.py
index a23dfe7..4bb1b21 100755
--- a/populate.py
+++ b/populate.py
@@ -30,11 +30,15 @@ widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='rules', index=1,
                             _config=json.dumps({
-                                'link': 'https://fedoraproject.org/wiki/I18N'
+                                'link': 'https://fedoraproject.org/wiki/I18N',
+                                'schedule_text': None,
+                                'schedule_link': None,
+                                'minutes_link': 'https://meetbot.fedoraproject.org/sresults/?group_id=i18n&type=team',
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='dummy', index=2)
+widget = hubs.models.Widget(plugin='meetings', index=2,
+                            _config=json.dumps({'calendar': 'i18n'}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -71,11 +75,15 @@ widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='rules', index=1,
                             _config=json.dumps({
-                                'link': 'https://fedoraproject.org/wiki/Marketing'
+                                'link': 'https://fedoraproject.org/wiki/Marketing',
+                                'schedule_text': None,
+                                'schedule_link': None,
+                                'minutes_link': 'http://meetbot.fedoraproject.org/sresults/?group_id=fedora-mktg&type=channel',
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='dummy', index=2)
+widget = hubs.models.Widget(plugin='meetings', index=2,
+                            _config=json.dumps({'calendar': 'marketing'}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -115,11 +123,15 @@ widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='rules', index=1,
                             _config=json.dumps({
-                                'link': 'https://fedoraproject.org/wiki/Design'
+                                'link': 'https://fedoraproject.org/wiki/Design',
+                                'schedule_text': 'Meetings are every other Tuesday at 16:00 UTC',
+                                'schedule_link': 'https://apps.fedoraproject.org/calendar/design/',
+                                'minutes_link': 'http://meetbot.fedoraproject.org/sresults/?group_id=fedora-design&type=channel',
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='dummy', index=2)
+widget = hubs.models.Widget(plugin='meetings', index=2,
+                            _config=json.dumps({'calendar': 'design'}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -160,11 +172,15 @@ widget = hubs.models.Widget(plugin='stats', index=0)
 hub.widgets.append(widget)
 widget = hubs.models.Widget(plugin='rules', index=1,
                             _config=json.dumps({
-                                'link': 'https://fedoraproject.org/wiki/Infrastructure'
+                                'link': 'https://fedoraproject.org/wiki/Infrastructure',
+                                'schedule_text': 'We meet weekly in #fedora-meeting at 18:00 UTC',
+                                'schedule_link': 'https://apps.fedoraproject.org/calendar/infrastructure/',
+                                'minutes_link': 'http://meetbot.fedoraproject.org/sresults/?group_id=infrastructure&type=team',
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='dummy', index=2)
+widget = hubs.models.Widget(plugin='meetings', index=2,
+                            _config=json.dumps({'calendar': 'infrastructure'}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget

